import pandas as pd
import numpy as np
from statsmodels.tsa.stattools import adfuller
from pmdarima import auto_arima
from statsmodels.tsa.arima_model import ARIMA
from statsmodels.tsa.arima_model import ARIMA
from sklearn.metrics import mean_squared_error
from math import sqrt

# Ignore harmless warnings
import warnings

warnings.filterwarnings("ignore")

df = pd.read_csv('data/topics.csv', index_col='Date', parse_dates=True)
df = df.dropna()
print('Shape of data', df.shape)
print(df.head())


def adf_test(dataset):
    dftest = adfuller(dataset, autolag='AIC')
    print("1. ADF : ", dftest[0])
    print("2. P-Value : ", dftest[1])
    print("3. Num Of Lags : ", dftest[2])
    print("4. Num Of Observations Used For ADF Regression and Critical Values Calculation :", dftest[3])
    print("5. Critical Values :")
    for key, val in dftest[4].items():
        print("\t", key, ": ", val)


adf_test(df['youtube'])

stepwise_fit = auto_arima(df['youtube'], suppress_warnings=True)

print(stepwise_fit.summary())


model = ARIMA(df['youtube'], order=(1, 0, 3))
model = model.fit()
df.tail()

model.save('models/youtube.pkl')

# index_future_dates = pd.date_range(start='2021-10-1', end='2021-10-31')
# # print(index_future_dates)
# pred = model.predict(start=len(df), end=len(df) + 30, typ='levels').rename('ARIMA Predictions')
# # print(comp_pred)
# pred.index = index_future_dates
# print(pred)
