from ibm_watson import SpeechToTextV1
from ibm_cloud_sdk_core.authenticators import IAMAuthenticator
import subprocess
import os

apikey = 'eC0Nj4kI5fPDAvJS4QuHJs66FEzYNx7neFy2aGx6XTl0'
url = 'https://api.au-syd.speech-to-text.watson.cloud.ibm.com/instances/e68ae92f-81ff-4e3b-92f7-d7385afd9e7e'


def convert_audio_to_text():
    authenticator = IAMAuthenticator(apikey)
    stt = SpeechToTextV1(authenticator=authenticator)
    stt.set_service_url(url)

    print("file converting..")
    command = 'ffmpeg -i audio.wav -vn -ar 44100 -ac 2 -b:a 192k audio.mp3'
    subprocess.call(command, shell=True)
    command = 'ffmpeg -i audio.mp3 -f segment -segment_time 360 -c copy %03d.mp3'
    subprocess.call(command, shell=True)
    print("file converted!")

    files = []
    for filename in os.listdir('.'):
        if filename.endswith(".mp3") and filename != 'audio.mp3':
            files.append(filename)
    files.sort()

    print('Now, Please wait...')

    results = []
    for filename in files:
        with open(filename, 'rb') as f:
            res = stt.recognize(audio=f, content_type='audio/mp3', model='en-AU_NarrowbandModel', \
                                inactivity_timeout=360).get_result()
            results.append(res)

    text = []
    for file in results:
        for result in file['results']:
            temp = result['alternatives'][0]['transcript'].rstrip() + '.\n'
            temp.lower()
            text.append(temp)
    print('Audio to text converted')

    with open('output.txt', 'w') as out:
        out.writelines(text)

    # remove created files
    for filename in files:
        os.remove(filename)
    os.remove('audio.mp3')
    os.remove('audio.wav')

    print('Audio file deleted...')
